#include "Hunter.h"

#include "Global.h"
#include "GameState.h"
#include "MainGame.h"
#include "Music.h"
#include "LevelSet.h"
#include <loadpng.h>
#include <algif.h>
#include <jpgalleg.h>
#include "Data.h"
#include "Menu.h"
#include "partypack/bitmap.h"

using namespace std;

Hunter *gSys;

Hunter::Hunter() {
	gSys = this;
	game = 0;
	mp = 0;
	levels = 0;
	datafile = 0;
}
Hunter::~Hunter() {
	if (maingame)
		delete maingame;
	if (mp)
		delete mp;
	if (levels)
		delete levels;
	if (datafile)
		unload_datafile(datafile);
}

void Hunter::setupGame() {
	install_mouse();
	algif_init();
	jpgalleg_init();
	register_png_file_type();

	datafile = load_datafile("data/fonts.dat");

	v10     = (FONT *)datafile[DATA_FONTS_10].dat;
	v10b	= (FONT *)datafile[DATA_FONTS_10b].dat;
	v10bi	= (FONT *)datafile[DATA_FONTS_10bi].dat;
	v10i	= (FONT *)datafile[DATA_FONTS_10i].dat;
	v8   	= (FONT *)datafile[DATA_FONTS_8].dat;
	v9		= (FONT *)datafile[DATA_FONTS_9].dat;
	futura = (FONT *)datafile[DATA_FONTS_main].dat;
	futura16 = (FONT *)datafile[DATA_FONTS_sub].dat;

	title = new Title;

	menu = new Menu;

	maingame = new MainGame;

	mp = new MusicPlayer;
	mp->play(rm.load<Music>("data/trollhunt.xm"));

	levels = new LevelSet;

	menu->setup(levels);

	game = title;

}
Hunter::Title::Title() {
	title = gSys->rm.load<Bitmap>("data/title.jpg")->getABitmap();
}
void Hunter::Title::update() {
	static bool press = false;
	if (keypressed()||mouse_b) {
		press = true;
		clear_keybuf();
	} else if (press)
		gSys->game = gSys->menu;

}

void Hunter::updateGameLogic() {
	poll_keyboard();
	poll_mouse();
	mp->update();

	if (key[KEY_ESC]) stop();
	static bool pressf9 = false;
	if (key[KEY_F9] && !pressf9) {
		toggleFullscreen();
		pressf9 = true;
	}
	if (!key[KEY_F9])
		pressf9 = false;

	game->update();
}

void Hunter::drawScreen(alBitmap &buffer) {
	game->draw(buffer);
}

