#include "LevelSet.h"
#include "Level.h"

#include <cctype>


LevelSet::LevelSet() {
	loadedRecent = false;
	currentLevel = 0;
}

LevelSet::~LevelSet() {
	clearList();
}

void LevelSet::clearList() {
	for (size_t i=0; i<levels.size(); i++)
		delete levels[i];
	levels.clear();
}

Level *LevelSet::getLevel() {
	if (currentLevel>=(int)levels.size()) return 0;
	return levels[currentLevel];
}

void LevelSet::restart() {
	loadedRecent = false;
	currentLevel = 0;
	makeList(levels.size());
}

int LevelSet::makeList(int maxLevels) {
	if (!loadedRecent)
		gSys->curl.download("http://www.allegro.cc/forums/recent.php","downloads/recent");

	clearList();

	FILE *f = fopen("downloads/recent","r");
	if (f) {
		int c = fgetc(f);
		int level = 0;
		string s;
		string url;
		int state = 0;
		while (c!=EOF) {
			switch (state) {
				case 0:
					if (c=='<') {
						state++;
						s = "";
					}
					break;
				case 1:
					if (c=='>')
						state = 0;
					else {
						s += c;
						if (s=="a href=\"/forums/view_thread.php?_id=") {
							state = 2;
							s = "";
						}
					}

					break;
				case 2:
					if (isdigit(c))
						s += c;
					else {
						if (url != s) {
							url = s;
							state = 3;
						} else
							state = 1;
						s = "";
					}
					break;
				case 3:
					if (c=='>')
						state = 4;
					break;
				case 4:
					if (c=='<') {
						levels.push_back(new Level(url,s,level++));
						if (level>=maxLevels) {
							c = EOF;
							continue;
						}
						state = 1;
						s="";
					} else
						s += c;

					break;
			}
			c = fgetc(f);
		}

		fclose(f);
	}

	return levels.size();
}

