
#include "Menu.h"
#include "LevelSet.h"
#include "Level.h"
#include "MainGame.h"

Menu::Menu() {

}
Menu::~Menu() {

}
void Menu::setup(LevelSet *_levels) {
	levels = _levels;
	loadstep = 0;
	levelCount = 0;
	loading=true;
}
void Menu::update() {
	if (loading && loadstep>0) {
		if (levelCount==0)
			levelCount = levels->makeList(10);
		else {
			Level *level = levels->getLevel();
			if (level) {
				gSys->maingame->setup(level, true);
				gSys->game = gSys->maingame;
			} else {
				gSys->stop();
			}
		}
		loading = false;
	} else if (!loading) {
		if (keypressed() || mouse_b) {
			readkey();
			loading=true;
		}
	}
}
void Menu::draw(alBitmap &bitmap) {
	bitmap.clear();
	if (loading) {
		for (int y=0; y<480; y+=2)
			bitmap.hLine(0,y,640,makecol(255,255,255));
		bitmap.rectFill(180,220,460,255,makecol(255,255,255));
		bitmap.rect    (180,220,460,255,makecol(0,0,0));
		bitmap.textoutCenter(gSys->futura,"Downloading...",320,217,makecol(0,0,0));

		loadstep++;
	} else {

		Level *level = levels->getLevel();
		if (level) {
			bitmap.textprintfCenter(gSys->futura, 320,180, makecol(255,255,255), -1, "Start Level %i/%i", level->getLevel(), levelCount);
			bitmap.textoutCenter(gSys->futura16, level->getTitle().c_str(),320,220, makecol(255,255,255));
			bitmap.textoutCenter(gSys->futura16, "Press a key...",320,260, makecol(255,255,255));
		} else {
			int score = gSys->maingame->getScore();
			if (score>0) {
				bitmap.textprintfCenter(gSys->futura, 320,180, makecol(255,255,255), -1, "WOOHOO! You win!");
				bitmap.textprintfCenter(gSys->futura16, 320,220, makecol(255,255,255), -1, "Final Score: %i", score);
				bitmap.textoutCenter(gSys->futura16, "Now wasn't that fun? =P",320,240, makecol(255,255,255));
				bitmap.textoutCenter(gSys->futura16, "Press a key to quit...",320,280, makecol(255,255,255));
			}
		}
	}

}


